#include <Arduino.h>
#include <Servo.h>

/*
  We learn:
  * Comments
  * Enums
  * Switch cases
  * Including Libraries
  * Some important Libraries
  * Using Classes
*/

enum States{
  S_OPEN, 
  T_OPENING,
  T_CLOSEING,
  S_CLOSED
};

const int SERVOPIN{5};
const int BUTTONPIN{7};

const int OPENPOS{180};
const int CLOSEPOS{90};

States state{S_CLOSED};
int position{CLOSEPOS};
bool buttonPressed(false);

Servo myDoorDrive;

void logTransition(String transition);

void setup() {
  Serial.begin(9600);
  pinMode(BUTTONPIN, INPUT);
  myDoorDrive.attach(SERVOPIN);
  myDoorDrive.write(CLOSEPOS);
}

void loop() {
  switch(state) {
    case S_OPEN:
      if(digitalRead(BUTTONPIN) == LOW) {
        state = T_CLOSEING;
        Serial.println("Entered Transition Closing");
      }
      break;
    case T_OPENING:
      logTransition("Opening...");
      position++;
      if(position >= OPENPOS) {
        state = S_OPEN;
        Serial.println("Entered State OPEN");
      }
      break;
    case S_CLOSED:
      if(digitalRead(BUTTONPIN) == HIGH) {
        state = T_OPENING;
        Serial.println("Entered Transition Opening");
      }
      break;
    case T_CLOSEING:
      logTransition("Closing...");
      position--;
      if(position <= CLOSEPOS) {
        state = S_CLOSED;
        Serial.println("Entered State CLOSE");
      }
      break;
  }
  myDoorDrive.write(position);
  delay(10);
}

void logTransition(String transition) {
  if(position % 15 != 0) {
    return;
  }
  Serial.println(transition);
}

void behaviordoor() {
  //Türe ist geschlossen (90°)
  state = S_CLOSED;
  //Button drücken -> Türe geht nach innen auf (180°)
  if(digitalRead(BUTTONPIN) == HIGH) {
    state = S_OPEN;
    Serial.println("Entered State OPEN");
  }
  //Button drücken -> Türe geht zu (90°)
  if(digitalRead(BUTTONPIN) == HIGH) {
    state = T_CLOSEING;
    Serial.println("Entered Transition Closing");
  }
  //Button drücken -> Türe geht nach aussen auf  (0°)
  if(digitalRead(BUTTONPIN) == HIGH) {
    state = S_OPEN;
    Serial.println("Entered State OPEN");
  }
  //Button drücken  ->Türe geht zu (90°)
    if(digitalRead(BUTTONPIN) == HIGH) {
    state = T_CLOSEING;
    Serial.println("Entered Transition Closing");
  }
  //Button drücken -> Türe geht nach innen auf (180°)
  if(digitalRead(BUTTONPIN) == HIGH) {
    state = S_OPEN;
    Serial.println("Entered State OPEN");
  }
}
