/**
 * @file MoistureSensor.h
 * @author Samuel Helbling (samuel.helbling@ost.ch)
 * @brief 
 * @version 0.2
 * @date 2022-03-31
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef MOISTURESENSOR_H
#define MOISTURESENSOR_H

#include <LiquidCrystal_AIP31068_I2C.h>

class MoistureSensor
{
public:
    MoistureSensor(uint8_t address);
    void begin();
    int watering();
    int getSoilMoisture();

private:
    int soilMoisture{10};
    uint8_t address;
    LiquidCrystal_AIP31068_I2C display{address, 8, 1};
    void writeToDisplay();

};

#endif